/*
 * Created on 17-May-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.vamsas.objects.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Hashtable;
import java.util.Vector;
import java.util.regex.Pattern;

import vamsas.objects.simple.Sequence;

/**
 * @author jimp
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SeqSet extends vamsas.objects.simple.SequenceSet {
  
  public static void write_Fasta(OutputStream os, Sequence[] seqs) throws IOException {
    write_Fasta(os, seqs, 80);
  }
  
  public static void write_Fasta(OutputStream os, Sequence[] seqs, boolean width80) throws IOException {
    write_Fasta(os, seqs, (width80) ? 80 : 0);
  }
  
  public static void write_Fasta(OutputStream os, Sequence[] seqs, int width) throws IOException {
    int i, nseq = seqs.length;
    BufferedWriter fasta_out = new BufferedWriter(new OutputStreamWriter(os));
    for (i=0; i<nseq; i++) {
      fasta_out.write(">"+seqs[i].getId()+"\n");
      if (width<=0) {
        fasta_out.write(seqs[i].getSeq()+"\n");
      } else {
        String tempseq = seqs[i].getSeq();
        int j=0, k=tempseq.length();
        while (j<k) {
          int d = k-j;
          if (d>=width) {
            fasta_out.write(tempseq, j, width);
          } else {
            fasta_out.write(tempseq, j, d);
          }
          fasta_out.write("\n");
          j+=width;
        }	  		    
      }
    }
    fasta_out.flush();
  }
  /**
   * TODO: introduce a dictionary parameter for qualified sequence symbols
   * Reads a sequence set from a stream - will only read prescribed amino acid
   * symbols. 
   * @param os
   * @return
   * @throws IOException
   */  
  public static Sequence[] read_SeqFasta(InputStream os) throws IOException {
    Vector seqs = new Vector();
    int nseq = 0;
    BufferedReader infasta = new BufferedReader(new InputStreamReader(os));
    
    /// TODO: decide on where this routine should live... current best guess is vamsas.objects.io
    String line;
    Sequence seq = null;
    Pattern aaMatch = Pattern.compile("[ARNDCQEGHILKMFPSTUWYV]", Pattern.CASE_INSENSITIVE);
    String sname = "", seqstr=null;
    do {
      line = infasta.readLine();
      if (line==null || line.startsWith(">")) {
        if (seqstr!=null) 
          seqs.add((Object) new Sequence(sname.substring(1), seqstr));
        sname = line; // remove >
        seqstr="";
      } else {	
        String subseq = Pattern.compile("//s+").matcher(line).replaceAll("");
        seqstr += subseq; 			
      }
    } while (line!=null);
    nseq = seqs.size();
    if (nseq>0) {
      // TODO:POSS: should really return a sequence if there's only one in the file.
      Sequence[] seqset = new Sequence[nseq];
      for (int i=0; i<nseq; i++) {
        seqset[i] = (Sequence) seqs.elementAt(i);
      }
      return seqset;
    }
    
    return null;
  }
  
  public static Hashtable uniquify(Sequence[] sequences) {
    // Generate a safely named sequence set and a hash to recover the sequence names
    Hashtable map = new Hashtable();
    for (int i = 0; i < sequences.length; i++) {
      String safename = new String("Sequence" + i);
      map.put(safename, sequences[i].getId());
      sequences[i].setId(safename);
    }
    return map;
  }
  
  public static boolean deuniquify(Hashtable map, Sequence[] sequences) {
    // recover unsafe sequence names for a sequence set
    boolean allfound = true;
    for (int i = 0; i < sequences.length; i++) {
      if (map.containsKey(sequences[i].getId())) {
        String unsafename = (String) map.get(sequences[i].getId());
        sequences[i].setId(unsafename);
      } else {
        allfound = false;
      }
    }
    return allfound;
  }
  
}
